/* partida.c
 * Autors: Sergio Blanco Cuaresma
 *         Ramn Quionero Bonmat
 *         Valentn Rey Gmez
 * Data: Gener del 2002
 * Descripci: Genera 2 fills, cadascun carga un proces vaixells per jugar entre
 * ells, un comena la partida i l'altre espera tir. Es comunicaran mitjanant 2
 * pipes.
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <assert.h>

int main (void) {
  pid_t pid_f1, pid_f2;
  int pipefd1[2], pipefd2[2];
  int n;
  char buffer1[BUFSIZ], buffer2[BUFSIZ];
  
  if (pipe(pipefd1)<0)    // Creaci pipe 1
  {
    fprintf(stderr, "Error en la primera Pipe\n");
    assert (n==14);
    _exit(1); 
  }
  if (pipe(pipefd2)<0)    // Creaci pipe 2
  {
    fprintf(stderr, "Error en la segona Pipe\n");
    assert (n==14);
    _exit(2);
  }

  if ((pid_f1=fork())== (pid_t) 0)                // proces primer fill
  {
    close(0);        // recibo datos
    dup(pipefd1[0]);
    close(1);                          // tanca stdout
    dup(pipefd2[1]);   // envio datos
    // Cargem proces amb nom Gates que esperara un tir, mostrant missatges per pantalla i
    // que te els seus vaixells guardats a pos1.txt
    execlp("./vaixells","./vaixells","Gates","0","1","pos1.txt",(char *)0);
    n=write(2,"ERROR en EXEC1\n",14);   // cas d'exec erroni
    assert(n==14);
    _exit(3);
  }
  else
  {
    if (pid_f1 > (pid_t) 0)                       // proces pare
    {
      if ((pid_f2=fork())== (pid_t) 0)                /* proces segon fill */
      {
        close(0);                        /* tanca stdin */
        dup(pipefd2[0]);   // recibo datos
        close(1);
        dup(pipefd1[1]);   // envio datos
        // Cargem proces amb nom Torvalds que comena partida, mostrant missatges per pantalla i
        // que te els seus vaixells guardats a posicions2.txt
        execlp("./vaixells","./vaixells","Torvalds","1","1", "pos2.txt",(char *)0);
        n=write(2,"ERROR en EXEC2\n",14);
        assert(n==14);
        _exit(4);
      }
      else
      {
        if (pid_f2 > (pid_t) 0)                       // proces pare, ha d'esperar que acabin els fills 
        {
          // El proces pare espera a que els processos fills acabin
          wait(NULL);    // Retorna el fill que finalitza primer
          wait(NULL);    // i ara el segon
          _exit(0);
        }
        else                               /* error en el fork del segon fill */
        {
          n=write(2,"ERROR en FORK del segon fill\n",14);
          assert(n==14);
          _exit(5);
        }
      }
    }
    else                               /* error en el fork del primer fill */
    {
     n=write(2,"ERROR en FORK del primer fill\n",14);
     assert(n==14);
     _exit(6);
    }
  }
}
  
  
